#NerdCave
# Rotating 3D cube - written by:
# https://github.com/mcauser/micropython-pcd8544/tree/791d4239d77b0d06192c7ab7903d81a72a53f992/examples
# Based on MicroViewCube.ino by Jim Lindblom @ SparkFun Electronics
# https://github.com/sparkfun/SparkFun_MicroView_Arduino_Library/blob/master/examples/MicroViewCube/MicroViewCube.ino

import utime
import pcd8544_fb
from machine import Pin, SPI
global aux
global counter
global clap_off
global clap_on
std1=1
std2=1
std3=1
aux=0
clap_on=1
clap_off=1
apagar=0
led1 = Pin(18,Pin.OUT)
led2 = Pin(25,Pin.OUT)
push1 = Pin(0, Pin.IN, Pin.PULL_UP)
push2 = Pin(1, Pin.IN, Pin.PULL_UP)
push3 = Pin(15, Pin.IN, Pin.PULL_UP)
button = Pin(14, Pin.IN, Pin.PULL_DOWN)
spi = SPI(0)
spi.init(baudrate=2000000, polarity=0, phase=0)
cs = Pin(5)
dc = Pin(4)
rst = Pin(8)
# set bl on/off
bl = Pin(9, Pin.OUT, value=1)
#initialize lcd
lcd = pcd8544_fb.PCD8544_FB(spi, cs, dc, rst)
led2.value(0)

def button_interrupt(pin):
  global aux
  global counter
  global clap_off
  global clap_on
  apagar=clap_on+clap_off
  if aux ==2:
      counter=counter+1
  else:
      counter=0
  if counter==clap_on:
      led2.value(1)
      led1.value(1)
  if counter==apagar:
      led2.value(0)
      led1.value(0)
      counter=0
button.irq(trigger=Pin.IRQ_RISING, handler=button_interrupt)

lcd.init(horizontal=True)
strg = "CLAP_OFF " + str(clap_off)
lcd.text('COUNT_CLAP', 0, 0, 1) 
lcd.text(strg,0, 12, 1)
lcd.clear()
lcd.show()
lcd.fill(0)   

while(True):
        
   if push1.value() == 0:
        utime.sleep_ms(10) 
        if push1.value() == 0:
            std1 = 0
            utime.sleep_ms(10)
   if push1.value() == 1 and std1 == 0:
       aux=aux+1
       if aux>2:
           aux=0
       std1=1
       
   if aux==2:
       if en==0:
           lcd.text('ENABLE', 0, 24, 1) 
           lcd.clear()
           lcd.show()
           lcd.fill(0)
           en=1
       
   if aux==0:
       counter=0
       en=0
       if push2.value() == 0:
           utime.sleep_ms(10) 
           if push2.value() == 0:
               std2 = 0
               utime.sleep_ms(10) 
       if push2.value() == 1 and std2 == 0:
           clap_off=clap_off+1
           if clap_off > 9:
               clap_off=1
           strg = "CLAP_OFF " + str(clap_off)
           lcd.text('COUNT_CLAP', 0, 0, 1) 
           lcd.text(strg,0, 12, 1)
           lcd.clear()
           lcd.show()
           lcd.fill(0)     
           std2=1
    
       if push3.value() == 0:
            utime.sleep_ms(10) 
            if push3.value() == 0:
                std3 = 0
                utime.sleep_ms(10) 
       if push3.value() == 1 and std3 == 0:
            clap_off=clap_off-1
            if clap_off == 0:
                clap_off=9
            strg = "CLAP_OFF " + str(clap_off)
            lcd.text('C0UNT_CLAP', 0, 0, 1) 
            lcd.text(strg,0, 12, 1)
            lcd.clear()
            lcd.show()
            lcd.fill(0)     
            std3=1
    
   if aux==1:
       counter=0
       en=0
       if push2.value() == 0:
           utime.sleep_ms(10) 
           if push2.value() == 0:
               std2 = 0
               utime.sleep_ms(10)
       if push2.value() == 1 and std2 == 0:
           clap_on=clap_on+1
           if clap_on > 9:
               clap_on=1
           strg = "CLAP_ON " + str(clap_on)
           lcd.text('C0UNT_CLAP', 0, 0, 1) 
           lcd.text(strg,0, 12, 1)
           lcd.clear()
           lcd.show()
           lcd.fill(0)     
           std2=1
           
       if push3.value() == 0:
           utime.sleep_ms(10) 
           if push3.value() == 0:
               std3 = 0
               utime.sleep_ms(10) 
       if push3.value() == 1 and std3 == 0:
            clap_on=clap_on-1
            if clap_on == 0:
                clap_on=9
            strg = "CLAP_ON " + str(clap_on)
            lcd.text('C0UNT_CLAP', 0, 0, 1) 
            lcd.text(strg,0, 12, 1)
            lcd.clear()
            lcd.show()
            lcd.fill(0)     
            std3=1

